//=============================================================================
// Gasbag. morph to ExGasbag - Credits to Epic's Team for another engine load
// Class ghosted for replacement tuned back by Base
//=============================================================================
class ExGasbag extends Gasbag;

var ExGasBag ParentBag; //Modify here

//-----------------------------------------------------------------------------
// Gasbag functions.

singular function Falling() //Singular ?
{
	SetPhysics(PHYS_Flying);
}

function PlayMeleeAttack()
{
	local vector adjust;

	adjust = vect(0,0,0);
	if ( Target == None || Target.bDeleteMe || ( Target.IsA('Pawn') && Pawn(Target).Health <= 0 ) ) 
		goto DoNothing; //Ye... Stay relaxed, bitch.
	else
	{
		adjust.Z = Target.CollisionHeight;
		Acceleration = AccelRate * Normal(Target.Location - Location + adjust);
	
		if (FRand() < 0.5)
		{
			PlaySound(Punch, SLOT_Interact);
			PlayAnim('TwoPunch');
		}
		else
		{
			PlaySound(Pound, SLOT_Interact);
			PlayAnim('Pound');
		}
	}
DoNothing:
}

function PlayRangedAttack()
{
	local vector adjust;

	adjust = vect(0,0,0);
	if ( Target == None || Target.bDeleteMe || ( Target.IsA('Pawn') && Pawn(Target).Health <= 0 ) )
		goto NoRanged;
	else
	{
		adjust.Z = Target.CollisionHeight + 20;
		Acceleration = AccelRate * Normal(Target.Location - Location + adjust);
		PlayAnim('Belch');
	}
NoRanged:
}

function SpawnBelch()
{
	if ( Target == None || Target.bDeleteMe || ( Target.IsA('Pawn') && Pawn(Target).Health <= 0 ) )
		goto NoBelch;
	else
		spawn(RangedProjectile ,self,'',Location,AdjustAim(ProjectileSpeed, Location, 400, bLeadTarget, bWarnTarget));
NoBelch:
}

function PunchDamageTarget()
{
	if ( Target == None || Target.bDeleteMe || ( Target.IsA('Pawn') && Pawn(Target).Health <= 0 ) )
		goto NoPunch;
	else
		if (MeleeDamageTarget(PunchDamage, (PunchDamage * 1300 * Normal(Target.Location - Location))))
			PlaySound(PunchHit, SLOT_Interact);
NoPunch:
}

function PoundDamageTarget()
{
	if ( Target == None || Target.bDeleteMe || ( Target.IsA('Pawn') && Pawn(Target).Health <= 0 ) )
		goto NoPound;
	else
		if (MeleeDamageTarget(PoundDamage, (PoundDamage * 800 * Normal(Target.Location - Location))))
			PlaySound(PunchHit, SLOT_Interact);
NoPound:
}

defaultproperties
{
     PunchDamage=12
     PoundDamage=25
     Punch=Sound'UnrealI.Gasbag.twopunch1g'
     Pound=Sound'UnrealI.Gasbag.twopunch1g'
     PunchHit=Sound'UnrealI.Gasbag.hit1g'
     CarcassType=Class'UnrealI.GassiusCarcass'
     Aggressiveness=0.700000
     RefireRate=0.500000
     bHasRangedAttack=True
     bMovingRangedAttack=True
     RangedProjectile=Class'UnrealI.GasBagBelch'
     ProjectileSpeed=600.000000
     Acquire=Sound'UnrealI.Gasbag.yell2g'
     Fear=Sound'UnrealI.Gasbag.injur2g'
     Roam=Sound'UnrealI.Gasbag.nearby1g'
     Threaten=Sound'UnrealI.Gasbag.yell3g'
     bCanStrafe=True
     MeleeRange=50.000000
     AirSpeed=200.000000
     JumpZ=10.000000
     SightRadius=2000.000000
     FovAngle=120.000000
     Health=200
     HitSound1=Sound'UnrealI.Gasbag.injur1g'
     HitSound2=Sound'UnrealI.Gasbag.injur2g'
     Die=Sound'UnrealI.Gasbag.death1g'
     CombatStyle=0.400000
     AmbientSound=Sound'UnrealI.Gasbag.amb2g'
     DrawType=DT_Mesh
     Mesh=LodMesh'UnrealI.GasBagM'
     CollisionRadius=56.000000
     CollisionHeight=36.000000
     Mass=120.000000
     RotationRate=(Pitch=8192,Yaw=65000,Roll=2048)
     MenuName="Gasbag"
     NameArticle=" a "
     bCollideActors=False
     bBlockActors=False
     bBlockPlayers=False
}
