class MHQuadShot expands TournamentWeapon; //fire and reload sound from UT defaults


#exec TEXTURE IMPORT NAME=GunPick FILE=MODELS\quadhand.pcx

//first person (scale fix, two hands, different anim lebels....)
//right handed                                X=0 Y=0 Z=0
#exec MESH IMPORT MESH=QuadShotHeldr ANIVFILE=MODELS\QuadShotHeldr_a.3D DATAFILE=MODELS\QuadShotHeldr_d.3D
#exec MESH ORIGIN MESH=QuadShotHeldr X=0 Y=0 Z=0 YAW=128
#exec MESH SEQUENCE MESH=QuadShotHeldr SEQ=still STARTFRAME=29  NUMFRAMES=1
#exec MESH SEQUENCE MESH=QuadShotHeldr SEQ=stillfire STARTFRAME=0  NUMFRAMES=1
#exec MESH SEQUENCE MESH=QuadShotHeldr SEQ=All  STARTFRAME=0  NUMFRAMES=30
#exec MESH SEQUENCE MESH=QuadShotHeldr SEQ=Fire STARTFRAME=0  NUMFRAMES=9
#exec MESH SEQUENCE MESH=QuadShotHeldr SEQ=Reload STARTFRAME=8  NUMFRAMES=21  Rate=24
#exec MESH SEQUENCE MESH=QuadShotHeldr SEQ=select STARTFRAME=25  NUMFRAMES=5  Rate=8 GROUP=Select
#exec MESH SEQUENCE MESH=QuadShotHeldr SEQ=down STARTFRAME=8  NUMFRAMES=6 Rate=20
#exec TEXTURE IMPORT NAME=QuadHand1 FILE=MODELS\quadhand.pcx GROUP="Skins"
#exec MESHMAP SCALE MESHMAP=QuadShotHeldr X=0.01 Y=0.01 Z=0.02
#exec MESHMAP SETTEXTURE MESHMAP=QuadShotHeldr NUM=1 TEXTURE=QuadHand1

//left handed
#exec MESH IMPORT MESH=QuadShotHeldl ANIVFILE=MODELS\QuadShotHeldl_a.3D DATAFILE=MODELS\QuadShotHeldl_d.3D
#exec MESH ORIGIN MESH=QuadShotHeldl X=0 Y=0 Z=0 Roll=128
#exec MESH SEQUENCE MESH=QuadShotHeldl SEQ=All  STARTFRAME=0  NUMFRAMES=30
#exec MESH SEQUENCE MESH=QuadShotHeldl SEQ=still STARTFRAME=29  NUMFRAMES=1
#exec MESH SEQUENCE MESH=QuadShotHeldl SEQ=stillfire STARTFRAME=0  NUMFRAMES=1
#exec MESH SEQUENCE MESH=QuadShotHeldl SEQ=Fire STARTFRAME=0  NUMFRAMES=9
#exec MESH SEQUENCE MESH=QuadShotHeldl SEQ=select STARTFRAME=25  NUMFRAMES=5  Rate=8 GROUP=Select
#exec MESH SEQUENCE MESH=QuadShotHeldl SEQ=down STARTFRAME=8  NUMFRAMES=6 Rate=20
#exec MESH SEQUENCE MESH=QuadShotHeldl SEQ=Reload STARTFRAME=8  NUMFRAMES=21 Rate=24
#exec MESHMAP SCALE MESHMAP=QuadShotHeldl X=0.01 Y=0.01 Z=0.02
#exec MESHMAP SETTEXTURE MESHMAP=QuadShotHeldl NUM=1 TEXTURE=QuadHand1

var int ShotsLeft;
var bool justfired;

replication
{
	// Thing the server should send to the client.
	reliable if( bNetOwner && (Role==ROLE_Authority) )
		shotsleft;
}

simulated function postbeginplay()
{
	super.postbeginplay();
	enable('tick'); //ensure that the tick is working.....
}

function float RateSelf( out int bUseAltMode )                                   //UsAaR33:  edited eightball botcode
{
	local float EnemyDist, Rating;
	local vector EnemyDir;
	local Pawn P;

	// don't recommend self if out of ammo
	if ( AmmoType.AmmoAmount <=0 )
		return -2;

	// by default use regular mode
	bUseAltMode = 0;
	P = Pawn(Owner);
	if ( P.Enemy == None )
		return AIRating;

	EnemyDir = P.Enemy.Location - Owner.Location;
	EnemyDist = VSize(EnemyDir);
	Rating = AIRating;

	// use alt if fairly close (and we don't need to worry about reload times)
	if ( EnemyDist < 360 &&(P.Health<60||shotsleft>1))
		bUseAltMode = 1;
	rating = FClamp(AIRating - (EnemyDist - 450) * 0.001, 0.2, AIRating);  //from flak cannon
	return rating;
}
// set which hand is holding weapon
function setHand(float Hand)
{
	Super.SetHand(Hand);
	if ( Hand == 1 )
		Mesh = mesh'MH2_NS_V2.QuadShotHeldL';
	else
		Mesh = mesh'MH2_NS_V2.QuadShotHeldR';
}

simulated function PostRender( canvas Canvas )   //render amount of clips left.....
{
	local PlayerPawn P;
	local float multiplier;
	Super.PostRender(Canvas);
	P = PlayerPawn(Owner);
	if  (P != None)  
	{
		if (p.myhud.isa('challengehud'))
			multiplier=0.8;
		else
			multiplier=0.9;
		//shotsleft=min(shotsleft, ammotype.ammoamount); //happened somehow, but I couldn't track it down, so the fix is right here...
		Canvas.DrawColor.B = 0;
		if (shotsleft < 3 )
		{//set colour according to shots left...
			Canvas.DrawColor.R = 255;
			Canvas.DrawColor.G = 0;
		}
		else
		{
			Canvas.DrawColor.R = 0;
			Canvas.DrawColor.G = 255;
		}
		if(P.Handedness != 1)
		{
			Canvas.SetPos(0.05 * Canvas.ClipX , multiplier * Canvas.ClipY);
            Canvas.Style = ERenderStyle.STY_Translucent;
            Canvas.Font = Canvas.SmallFont;
		}
		else
		{
			Canvas.SetPos(0.85 * Canvas.ClipX , multiplier * Canvas.ClipY);
			Canvas.Style = ERenderStyle.STY_Translucent;
			Canvas.Font = Canvas.SmallFont;
		}
		Canvas.DrawText("In Gun: "$ShotsLeft);
	}
}

simulated function PlayPostSelect()
{
	shotsleft=max(1, shotsleft); //hehe :D
	super.playpostselect();
}
function float SuggestAttackStyle()        //taken from flakcannon (tells about aggression if baddie's got weapon)
{
	return 0.3;
}

function float SuggestDefenseStyle()
{
	return -0.2;
}

function Fire( float Value )
{
	local int i;
  
	if (Shotsleft > 0)
	{
		AmmoType.UseAmmo(1);
		GotoState('NormalFire');
		if ( PlayerPawn(Owner) != None )
			PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag, ShakeVert);
		bPointing=True;
		bcanclientfire=True;
		ClientFire(Value);
		ShotsLeft--;
		for(i = 0; i < 10; i++)
		TraceFire(1.0);
		if ( Owner.bHidden )
			CheckVisibility();
	}
}

function AltFire( float Value )
{
	local int i, r;
	local vector X,Y,Z;
	local float altaccuracy;
	if( Shotsleft > 0 )
	{
		GetAxes(pawn(Owner).ViewRotation,x,y,z);
		x=normal(x);
		if (pawn(owner).baseeyeheight!=0)
		{ //duck check VA compatible:
			Pawn(Owner).SetLocation(Pawn(Owner).Location+vect(0,0,15));
			Pawn(Owner).Velocity-=(300*X); //simple little thingy.....
		}
		if (pawn(Owner).health > 19 && Pawn(Owner).baseeyeheight != 0) //duck check VA compatible:
			Pawn(Owner).health-=2;//haha too poweful :D
		else if (pawn(Owner).health > 7)
			Pawn(Owner).health--;
		bCanClientFire=True;
		ClientAltFire(Value);
		GotoState('AltFiring');
		if ( PlayerPawn(Owner) != None )
		PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag, ShakeVert);
		While ((ShotsLeft>0)&&(r<3))
		{
			AmmoType.UseAmmo(1);
			Shotsleft--;
			for (i = 0; i < 10; i++)
			{
				AltAccuracy = 3.0;
				if (pawn(owner).baseeyeheight==0) //ducking (VA compatible)
					AltAccuracy=AltAccuracy/1.721;
				TraceFire(AltAccuracy);
			}
			r++;
		}
		GotoState('AltFiring');
		if ( Owner.bHidden )
			CheckVisibility();
	}
}

simulated function PlayFiring()
{
	PlayOwnedSound(FireSound);
	justfired=true;
	PlayAnim('Fire', 0.5, 0.05);
	bMuzzleFlash++;
}

simulated function PlayAltFiring()
{
	PlayOwnedSound(AltFireSound);
	PlayAnim('Fire', 0.2, 0.05);
	bMuzzleFlash++;
	justfired=true;
}

state Reloading
{
	ignores fire, altfire, animend;

Begin:
	justfired=false;
	finishanim();

Reloader:
	PlayAnim('Reload', 1.0, 0.05); //sped up a lot
	PlayOwnedSound(Misc1sound, SLOT_None,1.0*Pawn(Owner).SoundDampening);
	FinishAnim();
	ShotsLeft++;
	if ( bChangeWeapon )
		GotoState('DownWeapon');
	else if ( Pawn(Owner).bFire!=0 )
		Global.Fire(0);
	else if ( Pawn(Owner).bAltFire!=0 )
		Global.AltFire(0);  
	else if ((PlayerPawn(Owner)!=None)&&(shotsleft<ammotype.ammoamount)&&(playerpawn(owner).bextra3!=0)&&(Shotsleft<12))
		Goto ('Reloader');
	else if ((PlayerPawn(Owner)==None)&&(shotsleft<ammotype.ammoamount)&&(Pawn(Owner).enemy==None)&&(Shotsleft<12))
		Goto ('Reloader');
	else GotoState('Idle'); //bye bye...
}

function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	if ( PlayerPawn(Owner) != None )
		PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag, ShakeVert);
  
	if (Other == Level) 
		Spawn(class'UT_HeavyWallHitEffect',,, HitLocation+HitNormal*9, Rotator(HitNormal));
	else if ( (Other!=self) && (Other!=Owner) && (Other != None) ) 
	{
		if ( !Other.IsA('Pawn') && !Other.IsA('Carcass') )
			spawn(class'UT_SpriteSmokePuff',,,HitLocation+HitNormal*9);
		if ( FRand() < 0.2 )
			X *= 2;
		Other.TakeDamage(5, Pawn(Owner), HitLocation, 5000.0*X, mydamagetype);
	}
}
////////////////////////////////
state NormalFire
{
	ignores Fire, AltFire, animend;

	function EndState()
	{
		Super.EndState();
		OldFlashCount = FlashCount;
	}

Begin:
	flashcount++;
	FinishAnim();
	if( ShotsLeft <= 0 && AmmoType.AmmoAmount > 0 )
	{
		Gotostate('Reloading');
	}
	else
		Finish();
}
//////////////////////////////////////
simulated function tick (float deltatime)
{
	super.tick(deltatime);
	if (Role < ROLE_Authority && Playerpawn(owner) != None && (PlayerPawn(Owner).bExtra3 != 0) && (Shotsleft<AmmoType.AmmoAmount)&&(Shotsleft<12)&&bcanclientfire&&!(Isinstate('clientfiring'))&&!Isinstate('clientaltfiring')&&!Isinstate('clientreload'))
	{ //play the anim and goto the state
		PlayAnim('Reload', 1.0, 0.05);
		Gotostate('ClientReload');
		PlayownedSound(Misc1Sound, SLOT_None,1.0*Pawn(Owner).SoundDampening);
	}
}

state ClientAltFiring //go to reload on the client...
{
	simulated function AnimEnd()
	{
		if( Shotsleft <= 0 &&ammotype.ammoamount>0)
		{
			PlayAnim('Reload', 1.0, 0.05);
			Gotostate('ClientReload');
			PlayOwnedSound(Misc1Sound, SLOT_None,1.0*Pawn(Owner).SoundDampening);
		}
		else
			super.animend();
	}
}

state ClientReload    //the client-side reload animations...
{
	simulated function bool ClientFire(float Value)
	{
		bForceFire = bForceFire || ( bCanClientFire && (Pawn(Owner) != None) && (AmmoType.AmmoAmount > 0) );
		return bForceFire;
	}

	simulated function bool ClientAltFire(float Value)
	{
		bForceAltFire = bForceAltFire || ( bCanClientFire && (Pawn(Owner) != None) && (AmmoType.AmmoAmount > 0) );
		return bForceAltFire;
	}

	simulated function AnimEnd()
	{
		shotsleft++; //?
		if ( bCanClientFire && (PlayerPawn(Owner) != None) && (AmmoType.AmmoAmount > 0) )
		{
			if ( bForceFire || (Pawn(Owner).bFire != 0) )
			{
				Global.ClientFire(0);
				return;
			}
			else if ( bForceAltFire || (Pawn(Owner).bAltFire != 0) )
			{
				Global.ClientAltFire(0);
				return;
			}
			else if (playerpawn(owner).bextra3!=0&&(Shotsleft<12)&&(shotsleft<ammotype.ammoamount))
			{
				PlayAnim('Reload', 1.0, 0.05);
				PlayOwnedSound(Misc1Sound, SLOT_None,1.0*Pawn(Owner).SoundDampening);
				return;
			}
		}
		GotoState('');
		Global.AnimEnd();
	}

	simulated function EndState()
	{
		bForceFire = false;
		bForceAltFire = false;
	}

	simulated function BeginState()
	{
		justfired=false;
		bForceFire = false;
		bForceAltFire = false;
	}
}

state ClientFiring  //go to reload on the client...
{
	simulated function AnimEnd()
	{
		if( Shotsleft <= 0 &&ammotype.ammoamount>0)
		{
			PlayAnim('Reload', 1.0, 0.05);
			PlayOwnedSound(Misc1Sound, SLOT_None,1.0*Pawn(Owner).SoundDampening);
			Gotostate('clientReload'); }
		else
			super.animend();
	}
}

state AltFiring
{
	ignores Fire, AltFire, animend;

	function EndState()
	{
		Super.EndState();
		OldFlashCount = FlashCount;
	}

Begin:
	flashcount++;
	FinishAnim();
	if( Shotsleft <= 0 && ammotype.ammoamount > 0)
		Gotostate('Reloading');
	else
		Finish();
}
//***************************************
// Weapon is up, but not firing
state Idle
{
	event Tick(float DeltaTime)
	{
		global.tick(deltatime);
		if (Pawn(Owner)!=None)
		{
			if(PlayerPawn(Owner)!=None)
			{
				if ((Shotsleft < AmmoType.AmmoAmount) && (ammotype.ammoamount > 0) && (playerpawn(owner).bextra3 !=0 ) && (Shotsleft != 9))
				{
					bCanClientFire=true;
					Gotostate('Reloading');
				}
			}
			else
			{
				//no one's pissing this guy off and he doesn't have a full clip... might as well reload
				if ((Shotsleft < AmmoType.AmmoAmount) && (ammotype.ammoamount > 0) && (Pawn(Owner).Enemy == None) && (Shotsleft < 12 ))
					Gotostate('Reloading');  }
		}
	}

	function bool PutDown()
	{
		GotoState('DownWeapon');
		return True;
	}

Begin:
	PlayIdleAnim();
	//log ("bwantreload var is set to"$bwantreload);
	bPointing=False;
	if ( (AmmoType != None) && (AmmoType.AmmoAmount<=0) ) 
		Pawn(Owner).SwitchToBestWeapon();  //Goto Weapon that has Ammo
	if ( Pawn(Owner).bFire!=0 )
		Fire(0.0);
	if ( Pawn(Owner).bAltFire!=0 )
		AltFire(0.0);  
}

simulated function PlayIdleAnim()
{
	if (justfired)
		PlayAnim ('stillfire',,0.05);
	else
		PlayAnim ('still',,0.05);
}

defaultproperties
{
     WeaponDescription="Classification: Quad-Barrelled Shotgun"
     ShotsLeft=100
     AmmoName=Class'UnrealShare.Shells'
//     Class'UnrealI.FlakBox'
     PickupAmmoCount=20
     bInstantHit=True
     bAltInstantHit=True
     FireOffset=(Y=-0.500000)
     MyDamageType=shot
     AIRating=0.200000
     FireSound=Sound'UnrealI.Rifle.RifleShot'
     AltFireSound=Sound'UnrealShare.flak.shot1'
     CockingSound=Sound'UnrealShare.AutoMag.Reload'
     SelectSound=Sound'UnrealShare.flak.Click'
     Misc1Sound=Sound'UnrealShare.AutoMag.Reload'
     DeathMessage="%o was blasted to bits by %k's %w."
     bDrawMuzzleFlash=True
     MuzzleScale=1.000000
     FlashY=0.110000
     FlashO=0.140000
     FlashC=0.030000
     FlashLength=0.010000
     FlashS=256
     MFTexture=Texture'Botpack.Rifle.MuzzleFlash2'
     AutoSwitchPriority=4
     InventoryGroup=3
     PickupMessage="You got the QuadShot."
     ItemName="QuadShot"
     PlayerViewOffset=(X=4.500000,Y=-2.500000,Z=-3.750000)
     PlayerViewMesh=LodMesh'MH2_NS_V2.QuadShotHeldr'
     PlayerViewScale=0.700000
     PickupViewMesh=LodMesh'UnrealI.QuadShotPickup'
     ThirdPersonMesh=LodMesh'UnrealI.QuadShotHeld'
     ThirdPersonScale=0.700000
     StatusIcon=Texture'Botpack.Icons.UseMini'
     bMuzzleFlashParticles=True
     MuzzleFlashStyle=STY_Translucent
     MuzzleFlashMesh=LodMesh'Botpack.muzzsr3'
     MuzzleFlashScale=0.100000
     MuzzleFlashTexture=Texture'Botpack.Skins.Muzzy3'
     PickupSound=Sound'UnrealShare.Pickups.WeaponPickup'
     Skin=Texture'UnrealI.Skins.QuadHand1'
     ActivateSound=Sound'UnrealI.Rifle.RiflePickup'
     Mesh=LodMesh'UnrealI.QuadShotPickup'
     bNoSmooth=False
     MultiSkins(0)=Texture'UnrealI.Skins.QuadHand1'
     MultiSkins(1)=Texture'UnrealI.Skins.QuadHand1'
     MultiSkins(2)=Texture'UnrealI.Skins.QuadHand1'
     MultiSkins(3)=Texture'UnrealI.Skins.QuadHand1'
     CollisionRadius=40.000000
     CollisionHeight=11.000000
     LightBrightness=228
     LightHue=30
     LightSaturation=71
     Mass=10.000000
}
