class NSMonsterEnd expands Trigger;

#exec Texture Import Name=MHEnd File=textures\MHEnd.pcx Group="Pics" Mips=Off Flags=2

function Touch( actor Other )
{
	local actor A;
	local pawn P, Best;

	if( IsRelevant( Other ) )
	{
		if ( ReTriggerDelay > 0 )
		{
		if ( Level.TimeSeconds - TriggerTime < ReTriggerDelay )
			return;
		TriggerTime = Level.TimeSeconds;
	}
	if( Event != '' )
		foreach AllActors( class 'Actor', A, Event )
			A.Trigger( Other, Other.Instigator );

		if ( Other.IsA('Pawn') && (Pawn(Other).SpecialGoal == self) )
	Pawn(Other).SpecialGoal = None;

	if( Message != "" )
		Other.Instigator.ClientMessage( Message );

	TriggerObjective(Pawn(Other));

      for ( P=Level.PawnList; P!=None; P=P.nextPawn )
      if ( P.bIsPlayer && ((Best == None) || (P.PlayerReplicationInfo.Score > Best.PlayerReplicationInfo.Score)) )
         Best = P;

	if( bTriggerOnceOnly )
		SetCollision(False);
	else if ( RepeatTriggerTime > 0 )
		SetTimer(RepeatTriggerTime, false);
	}
}

function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation,	Vector momentum, name damageType)
{
	local actor A;

	if ( bInitiallyActive && (TriggerType == TT_Shoot) && (Damage >= DamageThreshold) && (instigatedBy != None) )
	{
		if ( ReTriggerDelay > 0 )
		{
		if ( Level.TimeSeconds - TriggerTime < ReTriggerDelay )
			return;
		TriggerTime = Level.TimeSeconds;
	}
	if( Event != '' )
		foreach AllActors( class 'Actor', A, Event )
			A.Trigger( instigatedBy, instigatedBy );

	if( Message != "" )
		InstigatedBy.Instigator.ClientMessage( Message );

	if( bTriggerOnceOnly )
	SetCollision(False);

	TriggerObjective(InstigatedBy);
	}
}

function Trigger (Actor Other, Pawn EventInstigator)
{
	local actor A;

	if( Event != '' )
		foreach AllActors( class 'Actor', A, Event )
			A.Trigger( Other, Other.Instigator );
        TriggerObjective(EventInstigator);
}

function TriggerObjective(pawn Instigator)
{
	if (Level.Game.IsA('MonsterHunt'))
		Level.Game.EndGame("Hunt Successfull!");
	else
		log("MonsterEnd - TriggerObjective - MH == None. This map needs to be fixed for normal MH.");
}

defaultproperties
{
     bHidden=False
     InitialState=OtherTriggerTurnsOn
     Texture=Texture'MH2_NS_V2.Pics.MHEnd'
     bGameRelevant=True
}
